using System;
using System.Collections.Generic;
using System.IO;

namespace HaloMap.MetaContainers
{
    public class ugh_
    {
        public List<string> SoundNames = new List<string>(0);
        public List<SoundPermutationChunk> Permutations = new List<SoundPermutationChunk>(0);

        public List<SoundChoiceChunk> Choices = new List<SoundChoiceChunk>(0);

        public List<SoundType1Chunk> SoundChunks1 = new List<SoundType1Chunk>(0);

        public List<SoundType2Chunk> SoundChunks2 = new List<SoundType2Chunk>(0);

        public int PermutationsTranslation;
        public int ChoicesTranslation;
        public int SoundChunk1Translation;
        public int SoundNamesTranslation;

        public ugh_(ref TagMeta meta, int mapnumber)
        {
            BinaryReader BR = new BinaryReader(meta.MS);
            BR.BaseStream.Position = 16;
            int tempc = BR.ReadInt32();
            int tempr = BR.ReadInt32()-meta.magic-meta.offset;
            BR.BaseStream.Position = tempr;
            SoundNamesTranslation = tempr;
            for (int x = 0; x < tempc; x++)
            {
                SoundNames.Add(Maps.map[mapnumber].Strings.Name[BR.ReadUInt16()]);
                BR.ReadInt16();
            }


            BR.BaseStream.Position = 32;
            tempc = BR.ReadInt32();
            tempr = BR.ReadInt32() - meta.magic - meta.offset;
            BR.BaseStream.Position = tempr;
            PermutationsTranslation = tempr;
            for (int x = 0; x < tempc; x++)
            {

                SoundPermutationChunk tempp = new SoundPermutationChunk();
                tempp.unknown1 = BR.ReadInt32();
                tempp.unknown2 = BR.ReadInt32();
                tempp.choiceindex = BR.ReadUInt16();
                tempp.choicecount = BR.ReadUInt16();

                Permutations.Add(tempp);
            }

     

            BR.BaseStream.Position = 40;
            tempc = BR.ReadInt32();
            tempr = BR.ReadInt32() - meta.magic - meta.offset;
            BR.BaseStream.Position = tempr;
            ChoicesTranslation = tempr;
            for (int x = 0; x < tempc; x++)
            {


                SoundChoiceChunk tempp = new SoundChoiceChunk();
               tempp.NameIndex = BR.ReadUInt16();
               tempp.Name = Maps.map[mapnumber].Strings.Name[tempp.NameIndex];
               tempp.unknown1 = BR.ReadInt16();
               tempp.unknown2 = BR.ReadInt32();
               tempp.unknown3 = BR.ReadInt32();
                tempp.soundindex = BR.ReadUInt16();
                tempp.soundcount = BR.ReadUInt16();
             
                Choices.Add(tempp);
            }


            BR.BaseStream.Position = 64;
            tempc = BR.ReadInt32();
            tempr = BR.ReadInt32() - meta.magic - meta.offset;
            SoundChunk1Translation = tempr;
            for (int x = 0; x < tempc; x++)
            {
                BR.BaseStream.Position = tempr + (x * 12);
                SoundType1Chunk tempp = new SoundType1Chunk();
                tempp.offset = BR.ReadInt32();
                tempp.size = BR.ReadUInt16();
                Maps.map[mapnumber].Functions.ParsePointer(ref tempp.offset, ref tempp.rawLocation);
                tempp.unknown1  = BR.ReadUInt16();
                tempp.unknown2 = BR.ReadInt32();
                SoundChunks1.Add(tempp);
            }


            BR.BaseStream.Position = 80;
            tempc = BR.ReadInt32();
            tempr = BR.ReadInt32() - meta.magic - meta.offset;

            for (int x = 0; x < tempc; x++)
            {
                BR.BaseStream.Position = tempr + (x * 12)+8;
                SoundType2Chunk tempp = new SoundType2Chunk();
                tempp.offset = BR.ReadInt32();
                tempp.size = BR.ReadInt32();
                Maps.map[mapnumber].Functions.ParsePointer(ref tempp.offset, ref tempp.rawLocation);
                SoundChunks2.Add(tempp);
            }


        }
        [Serializable]
        public class SoundPermutationChunk
        {
            public int unknown1;
            public int unknown2;
            public ushort choiceindex;
            public ushort choicecount;
            public List<SoundChoiceChunk> Choices = new List<SoundChoiceChunk>(0);

        }
        [Serializable]
        public class SoundChoiceChunk
        {
            public ushort NameIndex;
            public string Name;
            public short unknown1;
            public int unknown2;
            public int unknown3;
            public ushort soundindex;
            public ushort soundcount;
            public List<SoundType1Chunk> SoundChunks1 = new List<SoundType1Chunk>(0);
        }

        [Serializable]
        public class SoundType1Chunk
        {
            public int offset;
            public MapTypes rawLocation;
            public ushort size;
            public ushort unknown1;
            public int unknown2;
        }

        public class SoundType2Chunk
        {
            public int offset;
            public MapTypes rawLocation;
            public int size;
        }

        public static void GetUghContainerInfo(int mapnumber)
        {
            TagMeta tempughmeta = new TagMeta();
            Maps.map[mapnumber].OpenMap(MapTypes.Internal);
            tempughmeta.ReadMetaFromMap(Maps.map[mapnumber].IndexHeader.metaCount - 1, mapnumber, true);
            Maps.map[mapnumber].ugh = new HaloMap.MetaContainers.ugh_(ref tempughmeta, mapnumber);
            Maps.map[mapnumber].CloseMap(); ;
        }
    }
}
