using System;
using System.Windows.Forms;
using System.IO;
namespace HaloMap
{

	/// <summary>
	/// Summary description for MathFunctions.
	/// </summary>
	public class MiscFunctions
	{
		#region Fields
		public MetaFunctions Meta;
		#endregion
		#region Constructor
		public MiscFunctions()
		{
			Meta=new MetaFunctions();
		}
		#endregion
		#region Methods
        public int FindModelByBaseClass(int tagnumber,int mapnumber)
        {
            if (tagnumber == -1) { return -1; }
            switch (Maps.map[mapnumber].HaloVersion)
            {
                case Map.HaloVersionEnum.Halo2:
                    switch (Maps.map[mapnumber].MetaInfo.TagType[tagnumber])
                    {
                        case "itmc":
                        case "vehi":
                        case "vehc":
                        case "bloc":
                        case "bipd":
                        case "mach":
                        case "ctrl":
                        case "scen":
                        case "eqip":
                        case "weap":
                            break;
                        default:
                            return -1;
                    }
                    Maps.map[mapnumber].OpenMap(MapTypes.Internal);
                    if (Maps.map[mapnumber].MetaInfo.TagType[tagnumber] == "vehc" | Maps.map[mapnumber].MetaInfo.TagType[tagnumber] == "itmc")
                    {
                        Maps.map[mapnumber].BR.BaseStream.Position = Maps.map[mapnumber].MetaInfo.Offset[tagnumber] + 20;
                        tagnumber = Maps.map[mapnumber].Functions.Meta.FindMetaByID(Maps.map[mapnumber].BR.ReadInt32(), mapnumber);
                    }
                    Maps.map[mapnumber].BR.BaseStream.Position = Maps.map[mapnumber].MetaInfo.Offset[tagnumber] + 56;
                    int temptag = Maps.map[mapnumber].Functions.Meta.FindMetaByID(Maps.map[mapnumber].BR.ReadInt32(), mapnumber);
                    if (temptag == -1) { return -1; }
                    Maps.map[mapnumber].BR.BaseStream.Position = Maps.map[mapnumber].MetaInfo.Offset[temptag] + 4;
                    int temptag2 = Maps.map[mapnumber].Functions.Meta.FindMetaByID(Maps.map[mapnumber].BR.ReadInt32(), mapnumber);
                    Maps.map[mapnumber].CloseMap();
                    return temptag2;
                case Map.HaloVersionEnum.Halo1:
                case Map.HaloVersionEnum.HaloCE:
                    Maps.map[mapnumber].OpenMap(MapTypes.Internal);
                    Maps.map[mapnumber].BR.BaseStream.Position = Maps.map[mapnumber].MetaInfo.Offset[tagnumber] + 56;
                     switch (Maps.map[mapnumber].MetaInfo.TagType[tagnumber])
                    {
                        case "itmc":
                        case "vehi":
                        case "bipd":
                        case "eqip":
                        case "weap":
                        case "scen":
                        case "mach":
                            break;
                        default:
                            return -1;
                    }
                    if (Maps.map[mapnumber].MetaInfo.TagType[tagnumber] == "itmc")
                    {
                        Maps.map[mapnumber].BR.BaseStream.Position = Maps.map[mapnumber].MetaInfo.Offset[tagnumber] + 140;
                        tagnumber = Maps.map[mapnumber].Functions.Meta.FindMetaByID(Maps.map[mapnumber].BR.ReadInt32(), mapnumber);
                    }
                    Maps.map[mapnumber].BR.BaseStream.Position = Maps.map[mapnumber].MetaInfo.Offset[tagnumber] + 52;
                    int temptag2x = Maps.map[mapnumber].Functions.Meta.FindMetaByID(Maps.map[mapnumber].BR.ReadInt32(), mapnumber);
                    Maps.map[mapnumber].CloseMap();
                    if (temptag2x == -1) { return -1; }
                    return temptag2x;
            }
            return -1;
        }

        
        public static void FormatIFPsInDirectory(string path)
        {
            string[] temps=Directory.GetFiles(path,"*.ifp2");

            for (int counter = 0; counter < 2; counter++)
            {
                foreach (string s in temps)
                {                    
                    IFPIO ifp = new IFPIO();
                    ifp.ReadIFP(s);
                    string tempentstring = s.Replace("ifp2", "ent");
                    tempentstring = tempentstring.Replace("ifp", "ent");
                    ifp.IFPOutput(tempentstring);
                }
                temps = Directory.GetFiles(path, "*.ifp");
            }
        }

		public int Padding(int size,int paddingchunksize)
		{
			int temp1=0;
			Math.DivRem(size,paddingchunksize,out temp1);
			if (temp1==0) { return 0;}
			int temp2=paddingchunksize-temp1;
			return temp2;
		}

		public void ParsePointer(ref int pointer,ref MapTypes type)
		{
			long tempmap=pointer & 0XC0000000;
			pointer=pointer & (int)0X3FFFFFFF;
			if (tempmap==0)
			{
				type=MapTypes.Internal;
				return;
			}
			else if (tempmap==0X80000000)
			{
				type=MapTypes.MPShared;
				
				return;
			}
			else if (tempmap==0XC0000000)
			{
				type=MapTypes.SPShared;
				return;
			}
			else if (tempmap==0X40000000)
			{
				type=MapTypes.MainMenu;
				return;
			}
			
		}

		
		#endregion
	}
}
