
// ----------------
// PluginManager.cs

using System;
using System.Collections.Generic;
using System.Reflection;
using System.IO;
using System.Windows.Forms;


namespace HaloMap
{
    public  class EntityPlugin:UserControl 
    {
        public string PluginName;
        public string Author;
        public int MapNumber;
        public string tagtype = "*.*";

        public EntityPlugin()
        {
            this.Dock = DockStyle.Fill;
            this.PluginName = "Default Plugin";
            InitializeComponent();
        }
        public virtual void Run(int mapnum,ref ToolStripProgressBar progressbar)
        {

        }

        public string GetName()
        {
            return this.PluginName;
        }

        private void InitializeComponent()
        {
            this.SuspendLayout();
            // 
            // EntityPlugin
            // 
            this.Name = "EntityPlugin";
            this.ResumeLayout(false);

        }
    }

    public class PluginManager
    {
        public PluginManagerList Plugin { get; } = new PluginManagerList();
        
        public class PluginManagerList : List<EntityPlugin>
        {
            public void Add(string pluginsPath)
            {
                if (!Directory.Exists(pluginsPath))
                    return;

                foreach (FileInfo file in new DirectoryInfo(pluginsPath).GetFiles())
                {
                    try
                    {
                        var asm = Assembly.LoadFile(file.FullName);

                        foreach (var type in asm.GetTypes())
                        {
                            if (type.BaseType == typeof(EntityPlugin))
                                Add((EntityPlugin)Activator.CreateInstance(type));
                        }
                    }
                    catch
                    {
                        continue;
                    }
                }
            }
        }
    }
}


