using System;
using System.Collections.Generic;
using System.ComponentModel;
using System.Data;
using System.Drawing;
using System.Text;
using System.Windows.Forms;
using System.IO;
using HaloMap;

namespace ScriptTools
{
    public partial class ScriptGlobalEditorForm : Form
    {
        public ScriptGlobalEditorForm()
        {
            InitializeComponent();
        }

        private void GlobalEditor_Load(object sender, EventArgs e)
        {
            for (int i = 0; i < ScriptValueTypes.Names.Length; i++)
            {
                if (ScriptValueTypes.Names[i] != "unknown")
                    ((DataGridViewComboBoxColumn)globalGrid.Columns[1]).Items.Add(ScriptValueTypes.Names[i]);
            }
            globalGrid.Rows.Add(ScriptListForm.globals.Length);
            for (int i = 0; i < ScriptListForm.globals.Length; i++)
            {
                string gbl = ScriptEditorForm.DecompileGlobal(ScriptListForm.globals[i]);
                int pos1 = gbl.IndexOf(' ');
                pos1 = gbl.IndexOf(' ', pos1 + 1);
                pos1 = gbl.IndexOf(' ', pos1 + 1);
                string value = gbl.Substring(pos1 + 1, gbl.Length - pos1 - 2);
                globalGrid.Rows[i].SetValues(new string[] { ScriptListForm.globals[i].Name, ScriptValueTypes.Names[ScriptListForm.globals[i].Type], value });
            }
        }

        private void globalGrid_CellEndEdit(object sender, DataGridViewCellEventArgs e)
        {
            DataGridViewCell cell = globalGrid.Rows[e.RowIndex].Cells[e.ColumnIndex];
            BinaryWriter bw = Maps.map[0].BW;
            switch (cell.ColumnIndex)
            {
                case 0:
                    string value = cell.Value as string;
                    if (value.Length > 32)
                        value = value.Substring(0, 32);
                    ScriptListForm.globals[cell.RowIndex].Name = value;
                    bw.BaseStream.Position = ScriptOffsetInfo.GlobalsStart + cell.RowIndex * 40;
                    for (int i = 0; i < 32; i++)
                    {
                        if (i >= value.Length)
                            bw.Write((byte)0);
                        else
                            bw.Write((byte)value[i]);
                    }
                    break;
                case 1:
                    value = cell.Value as string;
                    int type = ScriptValueTypes.GetIndex(value);
                    ScriptListForm.globals[cell.RowIndex].Type = type;
                    bw.BaseStream.Position = ScriptOffsetInfo.GlobalsStart + cell.RowIndex * 40 + 32;
                    bw.Write((byte)type);
                    break;
                case 2:
                    string tocomp = "(global " + ScriptValueTypes.Names[ScriptListForm.globals[cell.RowIndex].Type] + " " + ScriptListForm.globals[cell.RowIndex].Name + " " + (string)cell.Value + ")";
                    scriptInfo sinfo = ScriptEditorForm.comp(tocomp, ScriptListForm.globals[cell.RowIndex].ChunkNumber);
                    if (sinfo == null)
                        return;
                    bw.BaseStream.Position = ScriptOffsetInfo.ScriptSyntaxDataStart + ScriptListForm.globals[cell.RowIndex].ChunkNumber * 20;
                    byte[] data = new byte[sinfo.syntax.Count];
                    sinfo.syntax.CopyTo(data);
                    bw.Write(data);
                    break;
            }
        }
    }
}