using System;
using System.Collections.Generic;
using System.ComponentModel;
using System.Data;
using System.Drawing;
using System.Text;
using System.Windows.Forms;

namespace ScriptTools.ConstructorFiles
{
    public partial class ScriptInfoBox : Form
    {
        public ScriptDatabaseInfo[] scripts;

        public ScriptInfoBox()
        {
            InitializeComponent();
        }

        public ScriptInfoBox(int identity)
        {
            InitializeComponent();
            List<ScriptDatabaseInfo> temp = new List<ScriptDatabaseInfo>();
            for (int i = 0; ScriptDatabaseInfo.Entries[i].Identity <= identity; i++)
            {
                if (ScriptDatabaseInfo.Entries[i].Identity == identity)
                {
                    temp.Add(ScriptDatabaseInfo.Entries[i]);
                }
            }
            scripts = new ScriptDatabaseInfo[temp.Count];
            temp.CopyTo(scripts);
        }

        private void ScriptInfoBox_Load(object sender, EventArgs e)
        {
            for (int i = 0; i < scripts.Length; i++)
            {
                cboSelect.Items.Add(i);
            }
            this.Text = "Script Info - " + scripts[0].Name;
            loadScript(0);
        }

        public void loadScript(int num)
        {
            cboSelect.SelectedIndex = num;
            lblReturn.Text = ScriptValueTypes.Names[scripts[num].ReturnType];
            lstArgs.Items.Clear();
            for (int i = 0; i < scripts[num].Parameters.Count; i++)
            {
                lstArgs.Items.Add(ScriptValueTypes.Names[scripts[num].Parameters[i]]);
            }
        }

        private void cboSelect_SelectedIndexChanged(object sender, EventArgs e)
        {
            loadScript(cboSelect.SelectedIndex);
        }
    }
}