using System;
using System.IO;
using System.Windows.Forms;
namespace HaloMap
{

	public class MetaScanner
	{
		#region Classes
		public class XReflex:TagMeta.Reflexive
		{
			public int realtranslation;
			public int realtagnumber;
		}
		#endregion
		#region Constructor
		public MetaScanner()
		{
		
		}
		#endregion
		#region Methods
	

		public void ScanManually(ref TagMeta meta,int mapnumber)
		{
			BinaryReader BR=new BinaryReader(meta.MS);
			

			byte tempbyte,tempbyte2;
			short tempshort;
			int tempint,tempint2,tempintx;
            int oldint=0;
            
			int tempindex;
			int offset=0;
			int size=meta.size;
            int bspindex=-1;
            int bspstringidminoffset=0;
            if (meta.type=="sbsp") {
                bspindex = Maps.map[mapnumber].BSP.FindBSPNumberByBSPIdent(meta.ident);
                BR.BaseStream.Position = 340;
                bspstringidminoffset = BR.ReadInt32() - meta.magic-meta.offset ;
            }

			for (int y=0;y<2;y++)
			{
				BR.BaseStream.Position=offset;	
				for (int x=0;x<size;x+=4)
				{
                    if (x + 4 > size) { continue; }
					tempint=BR.ReadInt32();
                    tempint2 = tempint - meta.magic;
                    tempintx=(oldint>>16)&0xFFFF;
                    if (y == 1) { goto identstuff; }
                    if (x == 0 && Maps.map[mapnumber].HaloVersion == Map.HaloVersionEnum.HaloCE && bspindex >= 0) goto crap;
                    if (tempintx ==51914 && Maps.map[mapnumber].HaloVersion == Map.HaloVersionEnum.Halo1 && bspindex >= 0) goto crap;
                    if (tempintx != 0)
                    {
                        if (bspindex >= 0)
                        {
                            if (x > 11)
                            {
                                oldint = tempint;
                                goto identstuff;
                            }
                        }
                        else
                        {
                            oldint = tempint;
                            goto identstuff;
                        }
                    }
                crap:
                    if (bspindex >= 0)
                    {
                        if (tempint2 < Maps.map[mapnumber].BSP.sbsp[bspindex].offset || tempint2 >= Maps.map[mapnumber].BSP.sbsp[bspindex].size + Maps.map[mapnumber].BSP.sbsp[bspindex].offset) { oldint = tempint; goto identstuff; } 

                    }
                    else 
                    {
                        switch (Maps.map[mapnumber].HaloVersion)
                        {
                            case Map.HaloVersionEnum.Halo2:
                                if (tempint2 < Maps.map[mapnumber].MapHeader.indexOffset + Maps.map[mapnumber].MapHeader.metaStart || tempint2 >= Maps.map[mapnumber].MapHeader.indexOffset + Maps.map[mapnumber].MapHeader.metaStart + Maps.map[mapnumber].MapHeader.metaSize) { oldint = tempint; goto identstuff; }
                                break;
                            case Map.HaloVersionEnum.HaloCE:
                            case Map.HaloVersionEnum.Halo1:
                                if (tempint2 < Maps.map[mapnumber].MetaInfo.Offset[meta.tagnumber] || tempint2 >= Maps.map[mapnumber].MetaInfo.Offset[meta.tagnumber] + Maps.map[mapnumber].MetaInfo.Size[meta.tagnumber]) { oldint = tempint; goto identstuff; }
                                break;
                        }
                        
                    }

                    int tempint3 = 0 ;
                    if (bspindex >= 0)
                    {
                        tempint3 = Maps.map[mapnumber].BSP.sbsp[bspindex].tagnumber;
                        if (tempintx != 0) { oldint = 1; }
                        if (x == 0 && Maps.map[mapnumber].HaloVersion == Map.HaloVersionEnum.HaloCE) oldint = 1;
                    }
                    else
                    {
                        if (Maps.map[mapnumber].HaloVersion == Map.HaloVersionEnum.Halo2)
                        {
                            tempint3 = Maps.map[mapnumber].Functions.Meta.FindMetaByOffset(tempint2, mapnumber);
                        }
                        else
                            if (Maps.map[mapnumber].HaloVersion == Map.HaloVersionEnum.HaloCE || Maps.map[mapnumber].HaloVersion == Map.HaloVersionEnum.Halo1)
                         {
                             tempint3 = Maps.map[mapnumber].Functions.Meta.FindMetaByOffset(tempint2, mapnumber);
                             if (tempint3 != meta.tagnumber) { oldint = tempint; goto identstuff; }
                        }
                    }
                    if (tempint3!=-1)
                    {
                        int tempint4 = tempint2 - Maps.map[mapnumber].MetaInfo.Offset[tempint3];
                         XReflex r = new XReflex();
                   
                            r.chunkcount = oldint;
                        if (r.chunkcount == 0) { continue; }                        
                        r.chunksize = -1;
                            r.translation = tempint4;
                            r.pointstotagnumber = tempint3;


                            r.pointstotagtype = Maps.map[mapnumber].MetaInfo.TagType[tempint3];
                            r.pointstotagname = Maps.map[mapnumber].FileNames.Name[tempint3];
                                        r.offset = x-4;
                                        r.intag = meta.tagnumber;
                        
                                        r.intagtype = meta.type;
                                        r.intagname = meta.name;
                                        r.mapOffset = Maps.map[mapnumber].MetaInfo.Offset[r.intag] + (x - 4);                        
                                        r.description = "Reflexive";
                                        meta.items.Add(r);


                    }
                    oldint=tempint;
                        continue;
                    identstuff:
                       // if (tempint < Maps.map[mapnumber].MetaInfo.lowident | tempint > Maps.map[mapnumber].MetaInfo.highident) { continue; }
                        tempindex = Maps.map[mapnumber].Functions.Meta.FindMetaByID(tempint, mapnumber);
					if (tempindex!=-1)
					{
					
						TagMeta.Ident i=new TagMeta.Ident();
						i.ident=tempint;
						i.pointstotagnumber=tempindex;
                        i.pointstotagtype = Maps.map[mapnumber].MetaInfo.TagType[tempindex];
                        i.pointstotagname = Maps.map[mapnumber].FileNames.Name[tempindex];
						i.offset=x;
                        if (y == 1) { i.offset += 2; }
                        i.intag = meta.tagnumber;
                        i.intagtype = Maps.map[mapnumber].MetaInfo.TagType[i.intag];
                        i.intagname = Maps.map[mapnumber].FileNames.Name[i.intag];
						i.description="Ident";
                        i.mapOffset = Maps.map[mapnumber].MetaInfo.Offset[i.intag] + x;
                        if (y == 1) { i.mapOffset += 2; }
						meta.items.Add(i);
					}
				}
                if (y == 1 || Maps.map[mapnumber].HaloVersion != Map.HaloVersionEnum.Halo2)
                {
                    offset += 2;
                    size -= 4; 
                    continue;
                }
				BR.BaseStream.Position=offset;
				for (int x=0;x<size;x+=4)
				{
                    if (x + 4 > size) { continue; }
					tempshort=BR.ReadInt16();
					tempbyte2=BR.ReadByte();
					tempbyte=BR.ReadByte();
                    if (x < bspstringidminoffset) { continue; }
                    if (tempbyte2 == 0 && tempshort > 0 && tempshort < Maps.map[mapnumber].MapHeader.scriptReferenceCount && tempbyte == Maps.map[mapnumber].Strings.Length[tempshort])
					{
						TagMeta.String i=new TagMeta.String();
						i.offset=x;
                        i.name = Maps.map[mapnumber].Strings.Name[tempshort];
						i.intag=meta.tagnumber;
                        i.intagtype = Maps.map[mapnumber].MetaInfo.TagType[i.intag];
                        i.intagname = Maps.map[mapnumber].FileNames.Name[i.intag];
						i.description="String";
                        i.mapOffset = Maps.map[mapnumber].MetaInfo.Offset[i.intag] + x;
                       
						meta.items.Add(i);
					}
				}
				offset+=2;
				size-=4;
			}
           
		}

		public void ScanWithIFP(ref IFPIO ifp,ref TagMeta meta,int mapnumber)
		{
           
            meta.items.Clear();
			if (ifp.items!=null)
			{
				if (meta.parsed==true) 
				{
					meta.size=0;
					meta.MS=new MemoryStream();
                    Maps.map[mapnumber].BR.BaseStream.Position = meta.offset;
                    meta.MS.Write(Maps.map[mapnumber].BR.ReadBytes(ifp.headerSize), 0, ifp.headerSize);
                    meta.size += ifp.headerSize;
				}
				if (meta.type=="sbsp")
				{
                    int p = Maps.map[mapnumber].BSP.FindBSPNumberByBSPIdent(meta.ident);
                    CycleElements(ifp.items, ref meta, meta.offset, mapnumber, 1, meta.tagnumber, 0, Maps.map[mapnumber].BSP.sbsp[p].magic, 0);
				}
				else if (meta.type=="ltmp")
				{
                    int p = Maps.map[mapnumber].BSP.FindBSPNumberByLightMapIdent(meta.ident);
                    CycleElements(ifp.items, ref meta, meta.offset, mapnumber, 1, meta.tagnumber, 0, Maps.map[mapnumber].BSP.sbsp[p].magic, 0);
				}
				else
				{
                    CycleElements(ifp.items, ref meta, meta.offset, mapnumber, 1, meta.tagnumber, 0, Maps.map[mapnumber].SecondaryMagic, 0);
				}
			}
        
		}

		void CycleElements(object[] elements,ref TagMeta meta,int offset,int mapnumber,int count,int tagnumber,int chunksize,int magic,int previousparsedtranslation)
		{
            foreach (object o in elements)
            {
                IFPIO.BaseObject tempbase = (IFPIO.BaseObject)o;
                for (int x = 0; x < count; x++)
                {
                    
                    switch (tempbase.ObjectType)
                    {
                        case IFPIO.ObjectEnum.Reflexive:
                            IFPIO.Reflexive tempreflex = (IFPIO.Reflexive)tempbase;
                            XReflex r = new XReflex();
                            Maps.map[mapnumber].BR.BaseStream.Position = offset + tempreflex.offset + (x * chunksize);
                            
                            r.mapOffset = (int)Maps.map[mapnumber].BR.BaseStream.Position;
                            
                            r.chunkcount = Maps.map[mapnumber].BR.ReadInt32();
                            if (r.chunkcount == 0) { continue; }
                         
                            r.chunksize = tempreflex.chunkSize;
                            int tempshit = Maps.map[mapnumber].BR.ReadInt32();
                            r.translation = tempshit - meta.magic;

                            r.pointstotagnumber = Maps.map[mapnumber].Functions.Meta.FindMetaByOffset(r.translation, mapnumber);
                            if (meta.type == "sbsp" && r.pointstotagnumber!=-1)
                            {
                                // r.translation = tempshit - magic;
                                r.pointstotagnumber = meta.tagnumber;

                            }
                           
                            if (tempreflex.HasCount == false)
                            {
                            
                                r.translation = r.chunkcount - magic;
                                r.chunkcount = 1; 
                                r.pointstotagnumber = meta.tagnumber;
                            }
                   
                            r.description = tempreflex.name + " [" + x.ToString() + "]";
                            if (r.pointstotagnumber == -1) { continue; }

                            if (meta.parsed == true)
                            {

                                Maps.map[mapnumber].BR.BaseStream.Position = r.translation;
                                r.realtranslation = r.translation - Maps.map[mapnumber].MetaInfo.Offset[r.pointstotagnumber];
                                r.realtagnumber = r.pointstotagnumber;

                                int fuck = 0;
                                bool found = false;
                                for (int h = 0; h < meta.items.Count; h++)
                                {

                                    TagMeta.Item item = (TagMeta.Item)meta.items[h];
                                    if (item.type != TagMeta.ItemType.Reflexive) { continue; }
                                    XReflex rr = (XReflex)meta.items[h];

                                    if (r.realtranslation == rr.realtranslation && r.realtagnumber == rr.realtagnumber)
                                    {
                                        r.translation = rr.translation;
                                        r.pointstotagnumber = meta.tagnumber;
                                        r.pointstotagtype = meta.type;
                                        r.pointstotagname = meta.name;
                                        r.offset = previousparsedtranslation + (int)tempreflex.offset + (x * chunksize);
                                        r.intag = meta.tagnumber;
                                        r.intagtype = meta.type;
                                        r.intagname = meta.name;
                              
                                        meta.items.Add(r);
                                        meta.reflexivecount++;
                                        found = true;
                                        break;
                                    }



                                    fuck++;
                                }



                                if (found == false)
                                {
                                    r.translation = meta.size;
                                    meta.MS.SetLength((long)(meta.size + (r.chunksize * r.chunkcount)));
                                    meta.MS.Write(Maps.map[mapnumber].BR.ReadBytes(r.chunksize * r.chunkcount), 0, r.chunksize * r.chunkcount);
                                    meta.size += r.chunksize * r.chunkcount;
                                   // if (tempreflex.adding != 0)
                                  //  {
                                 //       int temppadsize = map.Functions.Padding(r.chunksize * r.chunkcount, (int)s.Padding);
                                   //     meta.MS.SetLength((long)(meta.size + (temppadsize)));
                                  //      byte[] tempbytes = new byte[temppadsize];
                                  //      meta.MS.Write(tempbytes, 0, temppadsize);
                                    //    meta.size += temppadsize;
                                   // }



                                    r.pointstotagnumber = meta.tagnumber;
                                    r.pointstotagtype = meta.type;
                                    r.pointstotagname = meta.name;
                                    r.offset = previousparsedtranslation + (int)tempreflex.offset + (x * chunksize);
                                    r.intag = meta.tagnumber;
                                    r.intagtype = meta.type;
                                    r.intagname = meta.name;
                            
                                    meta.items.Add(r);
                                    meta.reflexivecount++;

                                    CycleElements(tempreflex.items, ref meta, r.realtranslation + Maps.map[mapnumber].MetaInfo.Offset[r.realtagnumber], mapnumber , r.chunkcount, r.pointstotagnumber, tempreflex.chunkSize, magic, r.translation);
                                }
                                else
                                {
                                    found = false;
                                }

                            }
                            else
                            {
                                r.pointstotagtype = Maps.map[mapnumber].MetaInfo.TagType[r.pointstotagnumber];
                                r.pointstotagname = Maps.map[mapnumber].FileNames.Name[r.pointstotagnumber];
                                r.translation = r.translation - Maps.map[mapnumber].MetaInfo.Offset[r.pointstotagnumber];

                                r.offset = offset + tempreflex.offset + (x * chunksize);
                                r.mapOffset = r.offset;
                                r.offset -= Maps.map[mapnumber].MetaInfo.Offset[tagnumber];
                                r.intag = tagnumber;
                                r.intagtype = Maps.map[mapnumber].MetaInfo.TagType[r.intag];
                                r.intagname = Maps.map[mapnumber].FileNames.Name[r.intag];
                              
                                meta.items.Add(r);
                                meta.reflexivecount++;
                                CycleElements(tempreflex.items, ref meta, Maps.map[mapnumber].MetaInfo.Offset[r.pointstotagnumber] + r.translation, mapnumber , r.chunkcount, r.pointstotagnumber, tempreflex.chunkSize, magic, 0);
                            }
                            break;
                        case IFPIO.ObjectEnum.Ident:
                            IFPIO.Ident tempident = (IFPIO.Ident)tempbase;
                            TagMeta.Ident i = new TagMeta.Ident();
                            Maps.map[mapnumber].BR.BaseStream.Position = offset + tempident.offset + (x * chunksize);
                            i.mapOffset = (int)Maps.map[mapnumber].BR.BaseStream.Position;
                            i.ident = Maps.map[mapnumber].BR.ReadInt32();
                            i.pointstotagnumber = Maps.map[mapnumber].Functions.Meta.FindMetaByID(i.ident, mapnumber);
                            i.intag=tagnumber;
                            i.intagtype = Maps.map[mapnumber].MetaInfo.TagType[i.intag];
                            i.intagname = Maps.map[mapnumber].FileNames.Name[i.intag];
                            if (i.pointstotagnumber != -1)
						{
                            
                            i.pointstotagnumber = Maps.map[mapnumber].Functions.Meta.FindMetaByID(i.ident, mapnumber);
                            i.pointstotagtype = Maps.map[mapnumber].MetaInfo.TagType[i.pointstotagnumber];
                            i.pointstotagname = Maps.map[mapnumber].FileNames.Name[i.pointstotagnumber];
                            
						}
						else
						{
                            if (i.ident != -1)
                            {
                                int off = i.mapOffset - Maps.map[mapnumber].MetaInfo.Offset[tagnumber];
                                MessageBox.Show("There is a broken ident.\n" 
                                              + "Offset: " + off.ToString() + "\n"
                                              + "Tag Type: " + Maps.map[mapnumber].MetaInfo.TagType[tagnumber] + "\n"
                                              + "Tag Name: " + Maps.map[mapnumber].FileNames.Name[tagnumber]);
                            }
                            
							i.pointstotagnumber=-1;
							i.pointstotagname="Null";
						}
                        i.mapOffset = offset + tempident.offset + (x * chunksize);
                        i.offset = i.mapOffset - Maps.map[mapnumber].MetaInfo.Offset[tagnumber];
						if (meta.parsed==true)
						{
							i.offset=previousparsedtranslation+tempident.offset+(x*chunksize);
						}
						
                  
                        i.description = tempident.name + " [" + x.ToString() + "]"; ;
						meta.items.Add(i);
                            break;
                        case IFPIO.ObjectEnum.StringID:
                            IFPIO.SID tempstringid = (IFPIO.SID)tempbase;
                            TagMeta.String si = new TagMeta.String();
                            Maps.map[mapnumber].BR.BaseStream.Position = offset + tempstringid.offset + (x * chunksize);
                            si.mapOffset = (int)Maps.map[mapnumber].BR.BaseStream.Position;
                            si.id = Maps.map[mapnumber].BR.ReadUInt16();
                            if (si.id == 0 | si.id >= Maps.map[mapnumber].MapHeader.scriptReferenceCount) { continue; }
                            Maps.map[mapnumber].BR.ReadByte();
                            int temp = Maps.map[mapnumber].BR.ReadByte();
                            if (temp != Maps.map[mapnumber].Strings.Length[si.id]) { continue; }
                            si.mapOffset = offset + tempstringid.offset + (x * chunksize);
                            si.offset = si.mapOffset - Maps.map[mapnumber].MetaInfo.Offset[tagnumber];
                            if (meta.parsed == true)
                            {
                                si.offset = previousparsedtranslation + tempstringid.offset + (x * chunksize);
                            }
                            si.name = Maps.map[mapnumber].Strings.Name[si.id];
                            si.intag = tagnumber;
                            si.intagtype = Maps.map[mapnumber].MetaInfo.TagType[si.intag];
                            si.intagname = Maps.map[mapnumber].FileNames.Name[si.intag];
                            si.description = tempstringid.name + " [" + x.ToString() + "]"; ;
                            meta.items.Add(si);
                            break;
                    }
                 
                }
            }
            return;
		
			
        
		}
		#endregion
	}
}
