using System;
using System.Windows.Forms;

namespace entity
{
	/// <summary>
	/// Swizzles an array of pixels.
	/// </summary>
	/// 








	public sealed class Swizzler
	{
		public static byte[] Swizzle(byte[] raw, int offset, int width, int height, int depth, int bitCount, bool deswizzle)
		{
          //  MessageBox.Show("test");

            bitCount /= 8;
			int a = 0, b = 0;
            int tempsize = raw.Length;//width * height * bitCount;
            byte[] data = new byte[tempsize];
			MaskSet masks = new MaskSet(width, height, depth);
			
			offset=0;
            
           
			for(int y = 0; y < height; y++)
			{
				for(int x = 0; x < width; x++)
				{
					if(deswizzle)
					{
						a = ((y * width) + x) * bitCount;
						b = (Swizzle(x, y, -1, masks)) * bitCount;
					}
					else
					{
						b = ((y * width) + x) * bitCount;
						a = (Swizzle(x, y, -1, masks)) * bitCount;
					}
              
                        for (int i = offset; i < bitCount + offset; i++)
                            data[a + i] = raw[b + i];
                  
				
				}
			}

    
			//for(int u = 0; u < offset; u++)
				//data[u] = raw[u];
			//for(int v = offset + (height * width * depth * bitCount); v < data.Length; v++)
			//	data[v] = raw[v];

			return data;
		}

		public static byte[] Swizzle(byte[] raw, int width, int height, int depth, int bitCount, bool deswizzle)
		{
			return Swizzle(raw, 0, width, height, depth, bitCount, deswizzle);
		}

		private static int Swizzle(int x, int y, int z, MaskSet masks)
		{
			return SwizzleAxis(x, masks.x) | SwizzleAxis(y, masks.y)| (z ==-1 ? 0 : SwizzleAxis(z, masks.z));
		}

		private static int SwizzleAxis(int val, int mask)
		{
			int bit = 1;
			int result = 0;

			while(bit <= mask)
			{
				int test=mask & bit;
				if(test!=0)
				{
					result |= (val & bit);
				}
				else
				{
					val <<= 1;
				}
				bit <<= 1;
			}

			return result;
		}

		private class MaskSet
		{
            public int	x = 0;
			public int	y = 0;
			public int	z = 0;

			public MaskSet(int w, int h, int d)
			{
				int bit = 1;
				int index = 1;


				while(bit < w || bit < h || bit < d)
				{
                    //if (bit == 0) { break; }
					if(bit < w)
					{
						x |= index;
						index <<= 1;
					}
					if(bit < h)
					{
						y |= index;
						index <<= 1;
					}
					if(bit < d)
					{
						z |= index;
						index <<= 1;
					}
					bit <<= 1;
				}
			}
		}
	}
}
