﻿using System.Collections.Generic;

namespace ScriptTools
{
    public class ScriptDatabaseInfoComparer : IComparer<ScriptDatabaseInfo>
    {
        public int Compare(ScriptDatabaseInfo info1, ScriptDatabaseInfo info2)
        {
            if (info1 == null && info2 == null)
                return 0;
            else if (info1 == null && info2 != null)
                return -1;
            else if (info1 != null && info2 == null)
                return 1;
            else
            {
                if (info1.Identity > info2.Identity)
                    return 1;
                else if (info1.Identity < info2.Identity)
                    return -1;
                else
                {
                    ScriptTypeComparer b = new ScriptTypeComparer();
                    int a = b.Compare(info1.ReturnType, info2.ReturnType);
                    if (a != 0)
                        return a;
                    else
                    {
                        if (info1.Parameters.Count > info2.Parameters.Count)
                            return 1;
                        else if (info1.Parameters.Count < info2.Parameters.Count)
                            return -1;
                        else
                        {
                            for (int i = 0; i < info1.Parameters.Count; i++)
                            {
                                a = b.Compare(info1.Parameters[i], info2.Parameters[i]);
                                if (a != 0)
                                    return a;
                            }
                        }
                    }
                }
            }

            return 0;
        }
    }
}